# Tweety Bird

Tweety Bird is a deployment tracking service for Chef at Blue Jeans.



## API

### Version `GET /`

Return the application version.


### Create distribution `POST /:environment/:key_path {}`

Associate the `key_path` in `environment` with the `value_distribution` provided
in the request body, which must be valid JSON (see example below). Returns `404`
if a distribution for the `environment` and `key_path` already exists. Returns
`400` if the distribution is invalid.

    {
      "abc123": 0.1,
      "def456": 0.4,
      "ghi789": 0.5
    }


### Replace distribution `PUT /:environment/:key_path {}`

Associate the `key_path` in `environment` with the `value_distribution` provided
in the request body, which must be a valid JSON hash. Returns `404` if a
distribution for the `environment` and `key_path` does not exist. Returns `400`
if the distribution is invalid.


### Update distribution `PATCH /:environment/:key_path {}`

Merge the current distribution for the `key_path` in `environment` with the
`value_distribution` provided in the request body, which must be a valid JSON
hash. Returns `404` if a distribution for the `environment` and `key_path` does
not exist. Returns `400` if the distribution is invalid.


## Lookup distributions `GET /:environment`

Return all the distributions associated with the given `environment`. Returns
`404` if the environment does not exist.



## Changelog

### Pre-1.0.0

- Defining initial API
- Skeleton laid out